/*
 * LET BASIC = BASIC + 1
 * Copyright (C) 2006-2008 Rebecca G. Bettencourt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef ___B_EXPR_H___
#define ___B_EXPR_H___

#include "btype.h"
#include <ctype.h>

#define bx_identStart(c)     ( isalpha(c) || ((c)=='_') || ((c)=='$') || ((c)=='@') || ((c)=='#') || ((c)=='?') )
#define bx_identChar(c)      ( isalpha(c) || ((c)=='_') || ((c)=='$') || ((c)=='@') || ((c)=='#') || ((c)=='?') || isdigit(c) || ((c)=='.') )
#define bx_paramDelim(c)     ( (c)==','  || (c)==';'  )
#define bx_statementDelim(c) ( (c)==0    || (c)==':'  || (c)=='\n' || (c)=='\r' )
#define bx_space(c)          ( (c)==' '  || (c)=='\t' || (c)=='\f' || (c)=='\v' || (c)=='\xA0' )
#define bx_levelInc(c)       ( (c)=='('  || (c)=='['  || (c)=='{'  )
#define bx_levelDec(c)       ( (c)==')'  || (c)==']'  || (c)=='}'  )
#define bx_quote(c)          ( (c)=='\"' || (c)=='\'' || (c)=='`'  )
#define bx_toUpper(c)        ( islower(c)?((c)-32):(c) )

#define bx_min(a,b)          ( ((a)<(b))?(a):(b) )
#define bx_max(a,b)          ( ((a)>(b))?(a):(b) )

/* Include Path */
void bx_set_include_path(char * s);
char * bx_get_include_path();

/* Quoted String Functions */
char * bx_strchrq(char * s, char ch);
char * bx_strrchrq(char * ss, char ch);
char * bx_strstrq(char * s, char * ch);
char * bx_strrstrq(char * ss, char * ch);

char * bx_strcasechrq(char * s, char ch);
char * bx_strcaserchrq(char * ss, char ch);
char * bx_strcasestrq(char * s, char * ch);
char * bx_strcaserstrq(char * ss, char * ch);

/* String Format Checking Things */
int bx_isFloat(char * s);
int bx_isInt(char * s);
int bx_isOctal(char * s);
int bx_isHex(char * s);
int bx_isBinary(char * s);

/* Identifier String Functions */
int bx_verifyIdent(char * s);
char * bx_normalizeIdent(char * s);
b_type bx_autoTypeIdent(char * s);

/* Parsing Functions */
char * bx_ffToFirstStatement(char * buf);
char * bx_ffToEndOfLine(char * buf);
char * bx_ffToEndOfStatement(char * buf);
char * bx_ffToNextStatement(char * buf);
char * bx_ffToFirstParameter(char * buf);
char * bx_ffToEndOfParameter(char * buf);
char * bx_ffToNextParameter(char * buf);
char * bx_ffToFirstFParameter(char * buf);
char * bx_ffToEndOfFParameter(char * buf);
char * bx_ffToNextFParameter(char * buf);
char * bx_ffToIdentifierEnd(char * buf, int atStart);

/* Command & Function Calling */
int bx_callCommand(b_scope * sc, b_command * c, char * p);
int bx_callUsub(b_scope * osc, b_usub * us, char * p);
b_varl * bx_callFunction(b_scope * sc, b_function * f, char * o, int autoVars);
b_varl * bx_callUfunc(b_scope * osc, b_ufunc * uf, char * o, int autoVars);

/* Expression Evaluation and Program Execution */
b_varl * bx_eval(b_scope * sc, char * buf, int autoVars);
b_varl * bx_exec(b_scope * sc, char * buf);

#endif
