/*
 * LET BASIC = BASIC + 1
 * Copyright (C) 2006-2008 Rebecca G. Bettencourt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef ___B_F_BASIC_H___
#define ___B_F_BASIC_H___

#include "btype.h"

void bf_includepath1(b_scope * s, b_varl * a);
b_varl * bf_includepath0(b_scope * s);

void bf_new0(b_scope * s);
void bf_load1(b_scope * s, b_varl * a);
void bf_save1(b_scope * s, b_varl * a);

void bf_run0(b_scope * s);
void bf_subrun0(b_scope * s);
void bf_chain0(b_scope * s);
void bf_include0(b_scope * s);
void bf_list0(b_scope * s);

void bf_run1(b_scope * s, b_varl * a);
void bf_subrun1(b_scope * s, b_varl * a);
void bf_chain1(b_scope * s, b_varl * a);
void bf_include1(b_scope * s, b_varl * a);
void bf_list1(b_scope * s, b_varl * a);

void bf_lets(b_scope * s, char * c);
void bf_consts(b_scope * s, char * c);
void bf_dels(b_scope * s, char * c);
void bf_clear0(b_scope * s);
void bf_dims(b_scope * s, char * c);
void bf_redims(b_scope * s, char * c);
void bf_swap2(b_scope * s, b_varl * a, b_varl * b);

b_varl * bf_ifs(b_scope * s, char * c);

b_varl * bf_ubounds(b_scope * s, char * c);
b_varl * bf_clone1(b_scope * sc, b_varl * a);
b_varl * bf_news(b_scope * sc, char * ss);

b_varl * bf_errstr1(b_scope * sc, b_varl * a);
void bf_throw1(b_scope * sc, b_varl * a);

b_varl * bf_commands0(b_scope * s);
b_varl * bf_commands1(b_scope * s, b_varl * a);
b_varl * bf_functions0(b_scope * s);
b_varl * bf_functions1(b_scope * s, b_varl * a);

void bf_about0(b_scope * s);
b_varl * bf_about1(b_scope * s, b_varl * a);

b_command bf_includepath = {"INCLUDEPATH", 0, 0, 0, bf_includepath1, 0, 0, 0, 0};
b_function bf_includepathf = {"INCLUDEPATH", 0, bf_includepath0, 0, 0, 0, 0};
b_function bf_includepath_ = {"INCLUDEPATH$", 0, bf_includepath0, 0, 0, 0, 0};

b_command bf_newc = {"NEW", 0, 0, bf_new0, 0, 0, 0, 0, 0};
b_command bf_load = {"LOAD", 0, 0, 0, bf_load1, 0, 0, 0, 0};
b_command bf_save = {"SAVE", 0, 0, 0, bf_save1, 0, 0, 0, 0};
b_command bf_run = {"RUN", 0, 0, bf_run0, bf_run1, 0, 0, 0, 0};
b_command bf_subrun = {"SUBRUN", 0, 0, bf_subrun0, bf_subrun1, 0, 0, 0, 0};
b_command bf_chain = {"CHAIN", 0, 0, bf_chain0, bf_chain1, 0, 0, 0, 0};
b_command bf_include = {"INCLUDE", 0, 0, bf_include0, bf_include1, 0, 0, 0, 0};
b_command bf_list = {"LIST", 0, 0, bf_list0, bf_list1, 0, 0, 0, 0};

b_command bf_let = {"LET", 0, bf_lets, 0, 0, 0, 0, 0, 0};
b_command bf_const = {"CONST", 0, bf_consts, 0, 0, 0, 0, 0, 0};
b_command bf_del = {"DEL", 0, bf_dels, 0, 0, 0, 0, 0, 0};
b_command bf_clear = {"CLEAR", 0, 0, bf_clear0, 0, 0, 0, 0, 0};
b_command bf_dim = {"DIM", 0, bf_dims, 0, 0, 0, 0, 0, 0};
b_command bf_redim = {"REDIM", 0, bf_redims, 0, 0, 0, 0, 0, 0};
b_command bf_swap = {"SWAP", 0, 0, 0, 0, bf_swap2, 0, 0, 0};

b_function bf_if = {"IF", bf_ifs, 0, 0, 0, 0, 0, 0};
b_function bf_if_ = {"IF$", bf_ifs, 0, 0, 0, 0, 0, 0};
b_function bf___ = {"?", bf_ifs, 0, 0, 0, 0, 0, 0};

b_function bf_ubound = {"UBOUND", bf_ubounds, 0, 0, 0, 0, 0, 0};
b_function bf_clone = {"CLONE", 0, 0, bf_clone1, 0, 0, 0, 0};
b_function bf_new = {"NEW", bf_news, 0, 0, 0, 0, 0, 0};

b_function bf_errstr = {"ERRSTR", 0, 0, bf_errstr1, 0, 0, 0, 0};
b_function bf_errstr_ = {"ERRSTR$", 0, 0, bf_errstr1, 0, 0, 0, 0};
b_command bf_throw = {"THROW", 0, 0, 0, bf_throw1, 0, 0, 0, 0};

b_function bf_commands = {"COMMANDS", 0, bf_commands0, bf_commands1, 0, 0, 0, 0};
b_function bf_commands_ = {"COMMANDS$", 0, bf_commands0, bf_commands1, 0, 0, 0, 0};
b_function bf_functions = {"FUNCTIONS", 0, bf_functions0, bf_functions1, 0, 0, 0, 0};
b_function bf_functions_ = {"FUNCTIONS$", 0, bf_functions0, bf_functions1, 0, 0, 0, 0};

b_command bf_aboutc = {"ABOUT", 0, 0, bf_about0, 0, 0, 0, 0, 0};
b_function bf_about = {"ABOUT", 0, 0, bf_about1, 0, 0, 0, 0};
b_function bf_about_ = {"ABOUT$", 0, 0, bf_about1, 0, 0, 0, 0};

#endif
