/*
 * LET BASIC = BASIC + 1
 * Copyright (C) 2006-2008 Rebecca G. Bettencourt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef ___B_F_FILEIO_H___
#define ___B_F_FILEIO_H___

#include "btype.h"
#include <stdio.h>

void bf_open3(b_scope * sc, b_varl * mode, b_varl * fnum, b_varl * path);
void bf_close1(b_scope * sc, b_varl * fnum);
void bf_flush1(b_scope * sc, b_varl * fnum);

b_varl * bf_eof1(b_scope * sc, b_varl * fnum);
void bf_rewind1(b_scope * sc, b_varl * fnum);
void bf_seek2(b_scope * sc, b_varl * fnum, b_varl * pos);
void bf_seek3(b_scope * sc, b_varl * fnum, b_varl * pos, b_varl * org);
b_varl * bf_tell1(b_scope * sc, b_varl * fnum);

void bf_writes(b_scope * sc, char * c);
void bf_writebs(b_scope * sc, char * c);
void bf_writem3(b_scope * sc, b_varl * fnum, b_varl * addr, b_varl * len);

void bf_reads(b_scope * sc, char * c);
void bf_readbs(b_scope * sc, char * c);
void bf_readm3(b_scope * sc, b_varl * fnum, b_varl * addr, b_varl * len);

void bf_create1(b_scope * sc, b_varl * a);
void bf_delete1(b_scope * sc, b_varl * a);
void bf_rename2(b_scope * sc, b_varl * a, b_varl * b);
void bf_chdir1(b_scope * sc, b_varl * a);
b_varl * bf_cwdir0(b_scope * sc);
void bf_chmod2(b_scope * sc, b_varl * a, b_varl * mode);
void bf_chown3(b_scope * sc, b_varl * a, b_varl * b, b_varl * c);
void bf_mkdir1(b_scope * sc, b_varl * a);
void bf_rmdir1(b_scope * sc, b_varl * a);
void bf_link2(b_scope * sc, b_varl * a, b_varl * b);
void bf_symlink2(b_scope * sc, b_varl * a, b_varl * b);
void bf_system1(b_scope * sc, b_varl * a);

b_varl * bf_dir1(b_scope * sc, b_varl * a);
b_varl * bf_dir0(b_scope * sc);
void bf_cdir1(b_scope * sc, b_varl * a);
void bf_cdir0(b_scope * sc);

b_command bf_open = {"OPEN", 1, 0, 0, 0, 0, bf_open3, 0, 0};
b_command bf_close = {"CLOSE", 0, 0, 0, bf_close1, 0, 0, 0, 0};
b_command bf_flush = {"FLUSH", 0, 0, 0, bf_flush1, 0, 0, 0, 0};

b_function bf_eof = {"EOF", 0, 0, bf_eof1, 0, 0, 0, 0};
b_command bf_rewind = {"REWIND", 0, 0, 0, bf_rewind1, 0, 0, 0, 0};
b_command bf_seek = {"SEEK", 0, 0, 0, 0, bf_seek2, bf_seek3, 0, 0};
b_function bf_tell = {"TELL", 0, 0, bf_tell1, 0, 0, 0, 0};

b_command bf_write = {"WRITE", 0, bf_writes, 0, 0, 0, 0, 0, 0};
b_command bf_writeb = {"WRITEB", 0, bf_writebs, 0, 0, 0, 0, 0, 0};
b_command bf_writem = {"WRITEM", 0, 0, 0, 0, 0, bf_writem3, 0, 0};

b_command bf_read = {"READ", 0, bf_reads, 0, 0, 0, 0, 0, 0};
b_command bf_readb = {"READB", 0, bf_readbs, 0, 0, 0, 0, 0, 0};
b_command bf_readm = {"READM", 0, 0, 0, 0, 0, bf_readm3, 0, 0};

b_command bf_create = {"CREATE", 0, 0, 0, bf_create1, 0, 0, 0, 0};
b_command bf_delete = {"DELETE", 0, 0, 0, bf_delete1, 0, 0, 0, 0};
b_command bf_rename = {"RENAME", 0, 0, 0, 0, bf_rename2, 0, 0, 0};
b_command bf_chdir = {"CHDIR", 0, 0, 0, bf_chdir1, 0, 0, 0, 0};
b_function bf_cwdir = {"DIR", 0, bf_cwdir0, 0, 0, 0, 0, 0};
b_function bf_cwdir_ = {"DIR$", 0, bf_cwdir0, 0, 0, 0, 0, 0};
b_command bf_chmod = {"CHMOD", 0, 0, 0, 0, bf_chmod2, 0, 0, 0};
b_command bf_chown = {"CHOWN", 0, 0, 0, 0, 0, bf_chown3, 0, 0};
b_function bf_dir = {"LSDIR", 0, bf_dir0, bf_dir1, 0, 0, 0, 0};
b_function bf_dir_ = {"LSDIR$", 0, bf_dir0, bf_dir1, 0, 0, 0, 0};
b_command bf_cdir = {"LSDIR", 0, 0, bf_cdir0, bf_cdir1, 0, 0, 0, 0};
b_command bf_mkdir = {"MKDIR", 0, 0, 0, bf_mkdir1, 0, 0, 0, 0};
b_command bf_rmdir = {"RMDIR", 0, 0, 0, bf_rmdir1, 0, 0, 0, 0};
b_command bf_link = {"LINK", 0, 0, 0, 0, bf_link2, 0, 0, 0};
b_command bf_symlink = {"SYMLINK", 0, 0, 0, 0, bf_symlink2, 0, 0, 0};
b_command bf_system = {"SYSTEM", 0, 0, 0, bf_system1, 0, 0, 0, 0};

#endif
