/*
 * LET BASIC = BASIC + 1
 * Copyright (C) 2006-2008 Rebecca G. Bettencourt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef ___B_F_MATH_H___
#define ___B_F_MATH_H___

#include "btype.h"

b_varl * bf_maxs(b_scope * s, char * c);
b_varl * bf_mins(b_scope * s, char * c);
b_varl * bf_sums(b_scope * s, char * c);
b_varl * bf_avgs(b_scope * s, char * c);
b_varl * bf_prods(b_scope * s, char * c);
b_varl * bf_geoms(b_scope * s, char * c);
b_varl * bf_hypots(b_scope * s, char * c);
b_varl * bf_rsrs(b_scope * s, char * c);

b_varl * bf_ceil1(b_scope * sc, b_varl * a);
b_varl * bf_floor1(b_scope * sc, b_varl * a);
b_varl * bf_round1(b_scope * sc, b_varl * a);
b_varl * bf_trunc1(b_scope * sc, b_varl * a);

b_varl * bf_abs1(b_scope * sc, b_varl * a);
b_varl * bf_sgn1(b_scope * sc, b_varl * a);

b_varl * bf_sqrt1(b_scope * sc, b_varl * a);
b_varl * bf_cbrt1(b_scope * sc, b_varl * a);

b_varl * bf_ln1(b_scope * sc, b_varl * a);
b_varl * bf_log1(b_scope * sc, b_varl * a);
b_varl * bf_log2(b_scope * sc, b_varl * a, b_varl * b);
b_varl * bf_exp1(b_scope * sc, b_varl * a);

b_varl * bf_sin1(b_scope * sc, b_varl * a);
b_varl * bf_cos1(b_scope * sc, b_varl * a);
b_varl * bf_tan1(b_scope * sc, b_varl * a);
b_varl * bf_cot1(b_scope * sc, b_varl * a);
b_varl * bf_sec1(b_scope * sc, b_varl * a);
b_varl * bf_csc1(b_scope * sc, b_varl * a);

b_varl * bf_asin1(b_scope * sc, b_varl * a);
b_varl * bf_acos1(b_scope * sc, b_varl * a);
b_varl * bf_atan1(b_scope * sc, b_varl * a);
b_varl * bf_atan2(b_scope * sc, b_varl * a, b_varl * b);
b_varl * bf_acot1(b_scope * sc, b_varl * a);
b_varl * bf_asec1(b_scope * sc, b_varl * a);
b_varl * bf_acsc1(b_scope * sc, b_varl * a);

b_varl * bf_sinh1(b_scope * sc, b_varl * a);
b_varl * bf_cosh1(b_scope * sc, b_varl * a);
b_varl * bf_tanh1(b_scope * sc, b_varl * a);
b_varl * bf_coth1(b_scope * sc, b_varl * a);
b_varl * bf_sech1(b_scope * sc, b_varl * a);
b_varl * bf_csch1(b_scope * sc, b_varl * a);

b_varl * bf_asinh1(b_scope * sc, b_varl * a);
b_varl * bf_acosh1(b_scope * sc, b_varl * a);
b_varl * bf_atanh1(b_scope * sc, b_varl * a);
b_varl * bf_acoth1(b_scope * sc, b_varl * a);
b_varl * bf_asech1(b_scope * sc, b_varl * a);
b_varl * bf_acsch1(b_scope * sc, b_varl * a);

b_varl * bf_gamma1(b_scope * sc, b_varl * a);
b_varl * bf_pick2(b_scope * sc, b_varl * a, b_varl * b);
b_varl * bf_choose2(b_scope * sc, b_varl * a, b_varl * b);

b_varl * bf_gcd2(b_scope * sc, b_varl * a, b_varl * b);
b_varl * bf_lcm2(b_scope * sc, b_varl * a, b_varl * b);

void bf_randomize1(b_scope * sc, b_varl * a);
b_varl * bf_rnd0(b_scope * sc);
b_varl * bf_rnd1(b_scope * sc, b_varl * a);
b_varl * bf_rnd2(b_scope * sc, b_varl * a, b_varl * b);

b_function bf_max = {"MAX", bf_maxs, 0, 0, 0, 0, 0, 0};
b_function bf_min = {"MIN", bf_mins, 0, 0, 0, 0, 0, 0};
b_function bf_sum = {"SUM", bf_sums, 0, 0, 0, 0, 0, 0};
b_function bf_avg = {"AVG", bf_avgs, 0, 0, 0, 0, 0, 0};
b_function bf_average = {"AVERAGE", bf_avgs, 0, 0, 0, 0, 0, 0};
b_function bf_prod = {"PROD", bf_prods, 0, 0, 0, 0, 0, 0};
b_function bf_product = {"PRODUCT", bf_prods, 0, 0, 0, 0, 0, 0};
b_function bf_geom = {"GEOM", bf_geoms, 0, 0, 0, 0, 0, 0};
b_function bf_geomean = {"GEOMEAN", bf_geoms, 0, 0, 0, 0, 0, 0};
b_function bf_hypot = {"HYPOT", bf_hypots, 0, 0, 0, 0, 0, 0};
b_function bf_rsr = {"RSR", bf_rsrs, 0, 0, 0, 0, 0, 0};

b_function bf_ceil = {"CEIL", 0, 0, bf_ceil1, 0, 0, 0, 0};
b_function bf_floor = {"FLOOR", 0, 0, bf_floor1, 0, 0, 0, 0};
b_function bf_round = {"ROUND", 0, 0, bf_round1, 0, 0, 0, 0};
b_function bf_int = {"INT", 0, 0, bf_trunc1, 0, 0, 0, 0};
b_function bf_trunc = {"TRUNC", 0, 0, bf_trunc1, 0, 0, 0, 0};

b_function bf_abs = {"ABS", 0, 0, bf_abs1, 0, 0, 0, 0};
b_function bf_sgn = {"SGN", 0, 0, bf_sgn1, 0, 0, 0, 0};

b_function bf_sqr = {"SQR", 0, 0, bf_sqrt1, 0, 0, 0, 0};
b_function bf_sqrt = {"SQRT", 0, 0, bf_sqrt1, 0, 0, 0, 0};
b_function bf_cbrt = {"CBRT", 0, 0, bf_cbrt1, 0, 0, 0, 0};

b_function bf_ln = {"LN", 0, 0, bf_ln1, 0, 0, 0, 0};
b_function bf_log = {"LOG", 0, 0, bf_ln1, bf_log2, 0, 0, 0};
b_function bf_log10 = {"LOG10", 0, 0, bf_log1, 0, 0, 0, 0};
b_function bf_exp = {"EXP", 0, 0, bf_exp1, 0, 0, 0, 0};

b_function bf_sin = {"SIN", 0, 0, bf_sin1, 0, 0, 0, 0};
b_function bf_cos = {"COS", 0, 0, bf_cos1, 0, 0, 0, 0};
b_function bf_tan = {"TAN", 0, 0, bf_tan1, 0, 0, 0, 0};
b_function bf_cot = {"COT", 0, 0, bf_cot1, 0, 0, 0, 0};
b_function bf_sec = {"SEC", 0, 0, bf_sec1, 0, 0, 0, 0};
b_function bf_csc = {"CSC", 0, 0, bf_csc1, 0, 0, 0, 0};

b_function bf_asn = {"ASN", 0, 0, bf_asin1, 0, 0, 0, 0};
b_function bf_asin = {"ASIN", 0, 0, bf_asin1, 0, 0, 0, 0};
b_function bf_acs = {"ACS", 0, 0, bf_acos1, 0, 0, 0, 0};
b_function bf_acos = {"ACOS", 0, 0, bf_acos1, 0, 0, 0, 0};
b_function bf_atn = {"ATN", 0, 0, bf_atan1, bf_atan2, 0, 0, 0};
b_function bf_atan = {"ATAN", 0, 0, bf_atan1, bf_atan2, 0, 0, 0};
b_function bf_atantwo = {"ATAN2", 0, 0, 0, bf_atan2, 0, 0, 0};
b_function bf_acot = {"ACOT", 0, 0, bf_acot1, 0, 0, 0, 0};
b_function bf_asec = {"ASEC", 0, 0, bf_asec1, 0, 0, 0, 0};
b_function bf_acsc = {"ACSC", 0, 0, bf_acsc1, 0, 0, 0, 0};

b_function bf_sinh = {"SINH", 0, 0, bf_sinh1, 0, 0, 0, 0};
b_function bf_cosh = {"COSH", 0, 0, bf_cosh1, 0, 0, 0, 0};
b_function bf_tanh = {"TANH", 0, 0, bf_tanh1, 0, 0, 0, 0};
b_function bf_coth = {"COTH", 0, 0, bf_coth1, 0, 0, 0, 0};
b_function bf_sech = {"SECH", 0, 0, bf_sech1, 0, 0, 0, 0};
b_function bf_csch = {"CSCH", 0, 0, bf_csch1, 0, 0, 0, 0};

b_function bf_asinh = {"ASINH", 0, 0, bf_asinh1, 0, 0, 0, 0};
b_function bf_acosh = {"ACOSH", 0, 0, bf_acosh1, 0, 0, 0, 0};
b_function bf_atanh = {"ATANH", 0, 0, bf_atanh1, 0, 0, 0, 0};
b_function bf_acoth = {"ACOTH", 0, 0, bf_acoth1, 0, 0, 0, 0};
b_function bf_asech = {"ASECH", 0, 0, bf_asech1, 0, 0, 0, 0};
b_function bf_acsch = {"ACSCH", 0, 0, bf_acsch1, 0, 0, 0, 0};

b_function bf_gamma = {"GAMMA", 0, 0, bf_gamma1, 0, 0, 0, 0};
b_function bf_pick = {"PICK", 0, 0, 0, bf_pick2, 0, 0, 0};
b_function bf_choose = {"CHOOSE", 0, 0, 0, bf_choose2, 0, 0, 0};

b_function bf_gcd = {"GCD", 0, 0, 0, bf_gcd2, 0, 0, 0};
b_function bf_lcm = {"LCM", 0, 0, 0, bf_lcm2, 0, 0, 0};

b_command bf_randomize = {"RANDOMIZE", 0, 0, 0, bf_randomize1, 0, 0, 0, 0};
b_function bf_rnd = {"RND", 0, bf_rnd0, bf_rnd1, bf_rnd2, 0, 0, 0};

#endif
