/*
 * LET BASIC = BASIC + 1
 * Copyright (C) 2006-2008 Rebecca G. Bettencourt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef ___B_F_MEM_H___
#define ___B_F_MEM_H___

#include "btype.h"

b_varl * bf_peek1(b_scope * sc, b_varl * a);
b_varl * bf_peek2(b_scope * sc, b_varl * a, b_varl * b);
b_varl * bf_peekf1(b_scope * sc, b_varl * a);
b_varl * bf_peekf2(b_scope * sc, b_varl * a, b_varl * b);
b_varl * bf_peeks1(b_scope * sc, b_varl * a);
b_varl * bf_peeks2(b_scope * sc, b_varl * a, b_varl * b);

void bf_poke2(b_scope * sc, b_varl * a, b_varl * b);
void bf_poke3(b_scope * sc, b_varl * a, b_varl * b, b_varl * c);
void bf_pokef2(b_scope * sc, b_varl * a, b_varl * b);
void bf_pokef3(b_scope * sc, b_varl * a, b_varl * b, b_varl * c);
void bf_pokes2(b_scope * sc, b_varl * a, b_varl * b);
void bf_pokes3(b_scope * sc, b_varl * a, b_varl * b, b_varl * c);
void bf_pokem2(b_scope * sc, b_varl * a, b_varl * b);
void bf_pokem3(b_scope * sc, b_varl * a, b_varl * b, b_varl * c);

void bf_call1(b_scope * sc, b_varl * a);
void bf_call2(b_scope * sc, b_varl * a, b_varl * b);
void bf_call3(b_scope * sc, b_varl * a, b_varl * b, b_varl * c);
void bf_call4(b_scope * sc, b_varl * a, b_varl * b, b_varl * c, b_varl * d);

b_varl * bf_usr1(b_scope * sc, b_varl * a);
b_varl * bf_usr2(b_scope * sc, b_varl * a, b_varl * b);
b_varl * bf_usr3(b_scope * sc, b_varl * a, b_varl * b, b_varl * c);
b_varl * bf_usr4(b_scope * sc, b_varl * a, b_varl * b, b_varl * c, b_varl * d);

void bf_wait2(b_scope * sc, b_varl * a, b_varl * b);
void bf_wait3(b_scope * sc, b_varl * a, b_varl * b, b_varl * c);
void bf_wait4(b_scope * sc, b_varl * a, b_varl * b, b_varl * c, b_varl * d);

b_varl * bf_malloc1(b_scope * sc, b_varl * a);
b_varl * bf_calloc1(b_scope * sc, b_varl * a);
void bf_free1(b_scope * sc, b_varl * a);

void bf_bsave3(b_scope * sc, b_varl * a, b_varl * b, b_varl * c);
b_varl * bf_bload1(b_scope * sc, b_varl * a);
b_varl * bf_bload2f(b_scope * sc, b_varl * a, b_varl * b);
void bf_bload2(b_scope * sc, b_varl * a, b_varl * b);
void bf_bload3(b_scope * sc, b_varl * a, b_varl * b, b_varl * c);

b_function bf_peek = {"PEEK", 0, 0, bf_peek1, bf_peek2, 0, 0, 0};
b_function bf_peekf = {"PEEKF", 0, 0, bf_peekf1, bf_peekf2, 0, 0, 0};
b_function bf_peeks = {"PEEKS", 0, 0, bf_peeks1, bf_peeks2, 0, 0, 0};
b_command bf_poke = {"POKE", 0, 0, 0, 0, bf_poke2, bf_poke3, 0, 0};
b_command bf_pokef = {"POKEF", 0, 0, 0, 0, bf_pokef2, bf_pokef3, 0, 0};
b_command bf_pokes = {"POKES", 0, 0, 0, 0, bf_pokes2, bf_pokes3, 0, 0};
b_command bf_pokem = {"POKEM", 0, 0, 0, 0, bf_pokem2, bf_pokem3, 0, 0};

b_command bf_call = {"CALL", 0, 0, 0, bf_call1, bf_call2, bf_call3, bf_call4, 0};
b_function bf_usr = {"USR", 0, 0, bf_usr1, bf_usr2, bf_usr3, bf_usr4, 0};
b_command bf_wait = {"WAIT", 0, 0, 0, 0, bf_wait2, bf_wait3, bf_wait4, 0};

b_function bf_malloc = {"MALLOC", 0, 0, bf_malloc1, 0, 0, 0, 0};
b_function bf_calloc = {"CALLOC", 0, 0, bf_calloc1, 0, 0, 0, 0};
b_command bf_free = {"FREE", 0, 0, 0, bf_free1, 0, 0, 0, 0};

b_command bf_bsave = {"BSAVE", 0, 0, 0, 0, 0, bf_bsave3, 0, 0};
b_function bf_bloadf = {"BLOAD", 0, 0, bf_bload1, bf_bload2f, 0, 0, 0};
b_command bf_bload = {"BLOAD", 0, 0, 0, 0, bf_bload2, bf_bload3, 0, 0};

#endif
