/*
 * LET BASIC = BASIC + 1
 * Copyright (C) 2006-2008 Rebecca G. Bettencourt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef ___B_F_STRING_H___
#define ___B_F_STRING_H___

#include "btype.h"

b_varl * bf_trim1(b_scope * sc, b_varl * a);
b_varl * bf_ltrim1(b_scope * sc, b_varl * a);
b_varl * bf_rtrim1(b_scope * sc, b_varl * a);

b_varl * bf_left2(b_scope * sc, b_varl * a, b_varl * b);
b_varl * bf_mid2(b_scope * sc, b_varl * a, b_varl * b);
b_varl * bf_mid3(b_scope * sc, b_varl * a, b_varl * b, b_varl * c);
b_varl * bf_right2(b_scope * sc, b_varl * a, b_varl * b);

b_varl * bf_instr2(b_scope * sc, b_varl * a, b_varl * b);
b_varl * bf_rinstr2(b_scope * sc, b_varl * a, b_varl * b);

b_varl * bf_ucase1(b_scope * sc, b_varl * a);
b_varl * bf_lcase1(b_scope * sc, b_varl * a);
b_varl * bf_tcase1(b_scope * sc, b_varl * a);

b_varl * bf_len1(b_scope * sc, b_varl * a);

b_varl * bf_val1(b_scope * sc, b_varl * a);
b_varl * bf_eval1(b_scope * sc, b_varl * a);
b_varl * bf_str1(b_scope * sc, b_varl * a);

b_varl * bf_asc1(b_scope * sc, b_varl * a);
b_varl * bf_chr1(b_scope * sc, b_varl * a);
b_varl * bf_uni1(b_scope * sc, b_varl * a);
b_varl * bf_uchr1(b_scope * sc, b_varl * a);

b_varl * bf_spc1(b_scope * sc, b_varl * a);

b_varl * bf_countfields2(b_scope * sc, b_varl * a, b_varl * b);
b_varl * bf_nthfield3(b_scope * sc, b_varl * a, b_varl * b, b_varl * c);
b_varl * bf_replace3(b_scope * sc, b_varl * a, b_varl * b, b_varl * c);
b_varl * bf_replaceall3(b_scope * sc, b_varl * a, b_varl * b, b_varl * c);

b_varl * bf_hex1(b_scope * sc, b_varl * a);
b_varl * bf_oct1(b_scope * sc, b_varl * a);
b_varl * bf_bin1(b_scope * sc, b_varl * a);

b_function bf_trim = {"TRIM", 0, 0, bf_trim1, 0, 0, 0, 0};
b_function bf_trim_ = {"TRIM$", 0, 0, bf_trim1, 0, 0, 0, 0};
b_function bf_ltrim = {"LTRIM", 0, 0, bf_ltrim1, 0, 0, 0, 0};
b_function bf_ltrim_ = {"LTRIM$", 0, 0, bf_ltrim1, 0, 0, 0, 0};
b_function bf_rtrim = {"RTRIM", 0, 0, bf_rtrim1, 0, 0, 0, 0};
b_function bf_rtrim_ = {"RTRIM$", 0, 0, bf_rtrim1, 0, 0, 0, 0};

b_function bf_left = {"LEFT", 0, 0, 0, bf_left2, 0, 0, 0};
b_function bf_left_ = {"LEFT$", 0, 0, 0, bf_left2, 0, 0, 0};
b_function bf_mid = {"MID", 0, 0, 0, bf_mid2, bf_mid3, 0, 0};
b_function bf_mid_ = {"MID$", 0, 0, 0, bf_mid2, bf_mid3, 0, 0};
b_function bf_right = {"RIGHT", 0, 0, 0, bf_right2, 0, 0, 0};
b_function bf_right_ = {"RIGHT$", 0, 0, 0, bf_right2, 0, 0, 0};

b_function bf_instr = {"INSTR", 0, 0, 0, bf_instr2, 0, 0, 0};
b_function bf_rinstr = {"RINSTR", 0, 0, 0, bf_rinstr2, 0, 0, 0};

b_function bf_len = {"LEN", 0, 0, bf_len1, 0, 0, 0, 0};

b_function bf_ucase = {"UCASE", 0, 0, bf_ucase1, 0, 0, 0, 0};
b_function bf_ucase_ = {"UCASE$", 0, 0, bf_ucase1, 0, 0, 0, 0};
b_function bf_lcase = {"LCASE", 0, 0, bf_lcase1, 0, 0, 0, 0};
b_function bf_lcase_ = {"LCASE$", 0, 0, bf_lcase1, 0, 0, 0, 0};
b_function bf_tcase = {"TCASE", 0, 0, bf_tcase1, 0, 0, 0, 0};
b_function bf_tcase_ = {"TCASE$", 0, 0, bf_tcase1, 0, 0, 0, 0};

b_function bf_val = {"VAL", 0, 0, bf_val1, 0, 0, 0, 0};
b_function bf_eval = {"EVAL", 0, 0, bf_eval1, 0, 0, 0, 0};
b_function bf_eval_ = {"EVAL$", 0, 0, bf_eval1, 0, 0, 0, 0};
b_function bf_str = {"STR", 0, 0, bf_str1, 0, 0, 0, 0};
b_function bf_str_ = {"STR$", 0, 0, bf_str1, 0, 0, 0, 0};

b_function bf_asc = {"ASC", 0, 0, bf_asc1, 0, 0, 0, 0};
b_function bf_chr = {"CHR", 0, 0, bf_chr1, 0, 0, 0, 0};
b_function bf_chr_ = {"CHR$", 0, 0, bf_chr1, 0, 0, 0, 0};
b_function bf_uni = {"UNI", 0, 0, bf_uni1, 0, 0, 0, 0};
b_function bf_uchr = {"UCHR", 0, 0, bf_uchr1, 0, 0, 0, 0};
b_function bf_uchr_ = {"UCHR$", 0, 0, bf_uchr1, 0, 0, 0, 0};

b_function bf_spc = {"SPC", 0, 0, bf_spc1, 0, 0, 0, 0};

b_function bf_countfields = {"COUNTFIELDS", 0, 0, 0, bf_countfields2, 0, 0, 0};
b_function bf_nthfield = {"NTHFIELD", 0, 0, 0, 0, bf_nthfield3, 0, 0};
b_function bf_nthfield_ = {"NTHFIELD$", 0, 0, 0, 0, bf_nthfield3, 0, 0};
b_function bf_replace = {"REPLACE", 0, 0, 0, 0, bf_replace3, 0, 0};
b_function bf_replace_ = {"REPLACE$", 0, 0, 0, 0, bf_replace3, 0, 0};
b_function bf_replaceall = {"REPLACEALL", 0, 0, 0, 0, bf_replaceall3, 0, 0};
b_function bf_replaceall_ = {"REPLACEALL$", 0, 0, 0, 0, bf_replaceall3, 0, 0};

b_function bf_hex = {"HEX", 0, 0, bf_hex1, 0, 0, 0, 0};
b_function bf_hex_ = {"HEX$", 0, 0, bf_hex1, 0, 0, 0, 0};
b_function bf_oct = {"OCT", 0, 0, bf_oct1, 0, 0, 0, 0};
b_function bf_oct_ = {"OCT$", 0, 0, bf_oct1, 0, 0, 0, 0};
b_function bf_bin = {"BIN", 0, 0, bf_bin1, 0, 0, 0, 0};
b_function bf_bin_ = {"BIN$", 0, 0, bf_bin1, 0, 0, 0, 0};

#endif
