/*
 * LET BASIC = BASIC + 1
 * Copyright (C) 2006-2008 Rebecca G. Bettencourt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef ___B_F_TERMIO_H___
#define ___B_F_TERMIO_H___

#include "btype.h"

void bf_prints(b_scope * s, char * c);
void bf_inputs(b_scope * s, char * c);
void bf_input1(b_scope * s, b_varl * a);
void bf_input2(b_scope * s, b_varl * a, b_varl * b);
void bf_get1(b_scope * s, b_varl * a);

void bf_normal0(b_scope * s);
void bf_bold0(b_scope * s);
void bf_lowintensity0(b_scope * s);
void bf_underline0(b_scope * s);
void bf_flash0(b_scope * s);
void bf_inverse0(b_scope * s);
void bf_invisible0(b_scope * s);

void bf_home0(b_scope * s);
void bf_vtab1(b_scope * s, b_varl * a);
void bf_htab1(b_scope * s, b_varl * a);
void bf_gotoxy2(b_scope * s, b_varl * a, b_varl * b);
b_varl * bf_vpos0(b_scope * s);
b_varl * bf_hpos0(b_scope * s);
b_varl * bf_tab1(b_scope * s, b_varl * a);
b_varl * bf_rows0(b_scope * s);
b_varl * bf_cols0(b_scope * s);

void bf_fgcolor1(b_scope * s, b_varl * a);
void bf_bgcolor1(b_scope * s, b_varl * a);

void bf_echos(b_scope * s, char * ch);

b_command bf_print = {"PRINT", 0, bf_prints, 0, 0, 0, 0, 0, 0};
b_command bf__ = {"?", 0, bf_prints, 0, 0, 0, 0, 0, 0};
b_command bf_input = {"INPUT", 1, bf_inputs, 0, bf_input1, bf_input2, 0, 0, 0};
b_command bf_get = {"GET", 1, 0, 0, bf_get1, 0, 0, 0, 0};

b_command bf_normal = {"NORMAL", 0, 0, bf_normal0, 0, 0, 0, 0, 0};
b_command bf_bold = {"BOLD", 0, 0, bf_bold0, 0, 0, 0, 0, 0};
b_command bf_lowintensity = {"LOWINTENSITY", 0, 0, bf_lowintensity0, 0, 0, 0, 0, 0};
b_command bf_underline = {"UNDERLINE", 0, 0, bf_underline0, 0, 0, 0, 0, 0};
b_command bf_flash = {"FLASH", 0, 0, bf_flash0, 0, 0, 0, 0, 0};
b_command bf_inverse = {"INVERSE", 0, 0, bf_inverse0, 0, 0, 0, 0, 0};
b_command bf_invisible = {"INVISIBLE", 0, 0, bf_invisible0, 0, 0, 0, 0, 0};

b_command bf_home = {"HOME", 0, 0, bf_home0, 0, 0, 0, 0, 0};
b_command bf_cls = {"CLS", 0, 0, bf_home0, 0, 0, 0, 0, 0};
b_command bf_vtab = {"VTAB", 0, 0, 0, bf_vtab1, 0, 0, 0, 0};
b_command bf_htab = {"HTAB", 0, 0, 0, bf_htab1, 0, 0, 0, 0};
b_command bf_gotoxy = {"GOTOXY", 0, 0, 0, 0, bf_gotoxy2, 0, 0, 0};
b_function bf_vpos = {"VPOS", 0, bf_vpos0, 0, 0, 0, 0, 0};
b_function bf_hpos = {"HPOS", 0, bf_hpos0, 0, 0, 0, 0, 0};
b_function bf_pos = {"POS", 0, bf_hpos0, 0, 0, 0, 0, 0};
b_function bf_tab = {"TAB", 0, 0, bf_tab1, 0, 0, 0, 0};
b_function bf_rows = {"ROWS", 0, bf_rows0, 0, 0, 0, 0, 0};
b_function bf_cols = {"COLS", 0, bf_cols0, 0, 0, 0, 0, 0};

b_command bf_fgcolor = {"FGCOLOR", 0, 0, 0, bf_fgcolor1, 0, 0, 0, 0};
b_command bf_bgcolor = {"BGCOLOR", 0, 0, 0, bf_bgcolor1, 0, 0, 0, 0};

b_command bf_echo = {"ECHO", 0, bf_echos, 0, 0, 0, 0, 0, 0};

#endif
