/*
 * LET BASIC = BASIC + 1
 * Copyright (C) 2006-2008 Rebecca G. Bettencourt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "btype.h"
#include "vars.h"
#include <string.h>
#include <time.h>

b_varl * bf_time0(b_scope * sc)
{
	time_t tt = time(0);
	struct tm * t = localtime(&tt);
	struct tm e = { 0, 0, 0, 1, 0, 70, 0, 0, 0 };
	return bv_intToBv(mktime(t) - mktime(&e));
}

b_varl * bf_time1(b_scope * sc, b_varl * a)
{
	time_t tt = time(0);
	struct tm * t = localtime(&tt);
	if (bv_assertString(a)) {
		char buf[1024];
		strftime(buf, 1020, bv_getString(a), t);
		return bv_stringToBv(buf);
	} else if (bv_assertNumeric(a)) {
		switch (bv_getInt(a)) {
			case 0: return bf_time0(sc); break;
			case 1: return bv_intToBv(t->tm_year + 1900); break;
			case 2: return bv_intToBv(t->tm_mon + 1); break;
			case 3: return bv_intToBv(t->tm_mday); break;
			case 4: return bv_intToBv(t->tm_hour); break;
			case 5: return bv_intToBv(t->tm_min); break;
			case 6: return bv_intToBv(t->tm_sec); break;
			case 7: return bv_intToBv(t->tm_wday); break;
			case 8: return bv_intToBv(t->tm_yday); break;
			case 9: return bv_intToBv(t->tm_isdst); break;
			case 10: return bv_stringToBv(asctime(t)); break;
			default: return bv_intToBv(0); break;
		}
	} else {
		return 0;
	}
}

b_varl * bf_gmtime0(b_scope * sc)
{
	time_t tt = time(0);
	struct tm * t = gmtime(&tt);
	struct tm e = { 0, 0, 0, 1, 0, 70, 0, 0, 0 };
	return bv_intToBv(mktime(t) - mktime(&e));
}

b_varl * bf_gmtime1(b_scope * sc, b_varl * a)
{
	time_t tt = time(0);
	struct tm * t = gmtime(&tt);
	if (bv_assertString(a)) {
		char buf[1024];
		strftime(buf, 1020, bv_getString(a), t);
		return bv_stringToBv(buf);
	} else if (bv_assertNumeric(a)) {
		switch (bv_getInt(a)) {
			case 0: return bf_gmtime0(sc); break;
			case 1: return bv_intToBv(t->tm_year + 1900); break;
			case 2: return bv_intToBv(t->tm_mon + 1); break;
			case 3: return bv_intToBv(t->tm_mday); break;
			case 4: return bv_intToBv(t->tm_hour); break;
			case 5: return bv_intToBv(t->tm_min); break;
			case 6: return bv_intToBv(t->tm_sec); break;
			case 7: return bv_intToBv(t->tm_wday); break;
			case 8: return bv_intToBv(t->tm_yday); break;
			case 9: return bv_intToBv(t->tm_isdst); break;
			case 10: return bv_stringToBv(asctime(t)); break;
			default: return bv_intToBv(0); break;
		}
	} else {
		return 0;
	}
}

b_varl * bf_ticks0(b_scope * sc)
{
	clock_t c = clock();
	/* c = c * 60 / CLOCKS_PER_SEC; */
	return bv_intToBv(c);
}

