/*
 * LET BASIC = BASIC + 1
 * Copyright (C) 2006-2008 Rebecca G. Bettencourt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef ___B_F_APIGLUE_H___
#define ___B_F_APIGLUE_H___

#include "pz.h"
#include "btype.h"

#define MAKERGB(r,g,b) ( ((r)<<16) | ((g)<<8) | (b) )
#define GETRED(rgb)    ( ((rgb) >> 16) & 0xFF )
#define GETGREEN(rgb)  ( ((rgb) >>  8) & 0xFF )
#define GETBLUE(rgb)   ( ((rgb)      ) & 0xFF )
#define RGBTOTTK(rgb)  (ttk_makecol( ((rgb)>>16) & 0xFF, ((rgb)>>8) & 0xFF, (rgb) & 0xFF ))

/* tiwidgets.c */
typedef struct TiBuffer {
	char * text;
	int asize; /* allocated size */
	int usize; /* used size */
	int cpos; /* cursor position */
	int idata[4];
	void * data;
	int (*callback)(TWidget *, char *); /* callback function */
} TiBuffer;

ttk_color rgbtottk(int rgb);
int ttktorgb(ttk_color ttk);

int basic_checkerr();
void bf_pzrun1(b_scope * sc, b_varl * a);
void bf_termrun0(b_scope * sc);
void bf_termrun1(b_scope * sc, b_varl * a);
void bf_exit0(b_scope * sc);

b_varl * bf_ttkpodtype1(b_scope * sc, b_varl * a);
b_varl * bf_ttkbutton1(b_scope * sc, b_varl * a);
b_varl * bf_ttkmovewherefrom1(b_scope * sc, b_varl * a);
b_varl * bf_ttkdirtyness1(b_scope * sc, b_varl * a);
b_varl * bf_ttkevreturn1(b_scope * sc, b_varl * a);
b_varl * bf_ttkevretcustom1(b_scope * sc, b_varl * a);
b_varl * bf_ttkinputkey1(b_scope * sc, b_varl * a);
b_varl * bf_ttkbwcolor1(b_scope * sc, b_varl * a);

void bf_ondraws(b_scope * sc, char * s);
void bf_onscrolls(b_scope * sc, char * s);
void bf_onstaps(b_scope * sc, char * s);
void bf_onbuttons(b_scope * sc, char * s);
void bf_ondowns(b_scope * sc, char * s);
void bf_onhelds(b_scope * sc, char * s);
void bf_oninputs(b_scope * sc, char * s);
void bf_onframes(b_scope * sc, char * s);
void bf_ontimers(b_scope * sc, char * s);
void bf_ondestroys(b_scope * sc, char * s);
void bf_ontexts(b_scope * sc, char * s);

b_command bf_pzrun = {"PZRUN", 0, 0, 0, bf_pzrun1, 0, 0, 0, 0};
b_command bf_termrun = {"TERMRUN", 0, 0, bf_termrun0, bf_termrun1, 0, 0, 0, 0};
b_command bf_exit = {"EXIT", 0, 0, bf_exit0, 0, 0, 0, 0, 0};

b_function bf_ttkpodtype = {"TTK_POD", 0, 0, 0, bf_ttkpodtype1, 0, 0, 0, 0};
b_function bf_ttkbutton = {"TTK_BUTTON", 0, 0, 0, bf_ttkbutton1, 0, 0, 0, 0};
b_function bf_ttkmovewherefrom = {"TTK_MOVE", 0, 0, 0, bf_ttkmovewherefrom1, 0, 0, 0, 0};
b_function bf_ttkdirtyness = {"TTK_DIRTY", 0, 0, 0, bf_ttkdirtyness1, 0, 0, 0, 0};
b_function bf_ttkevreturn = {"TTK_EV", 0, 0, 0, bf_ttkevreturn1, 0, 0, 0, 0};
b_function bf_ttkevretcustom = {"TTK_EV_RET", 0, 0, 0, bf_ttkevretcustom1, 0, 0, 0, 0};
b_function bf_ttkinputkey = {"TTK_INPUT", 0, 0, 0, bf_ttkinputkey1, 0, 0, 0, 0};
b_function bf_ttkbwcolor = {"TTK_BWCOLOR", 0, 0, 0, bf_ttkbwcolor1, 0, 0, 0, 0};

b_command bf_ondraw = {"ONDRAW", bf_ondraws, 0, 0, 0, 0, 0, 0};
b_command bf_onscroll = {"ONSCROLL", bf_onscrolls, 0, 0, 0, 0, 0, 0};
b_command bf_onstap = {"ONSTAP", bf_onstaps, 0, 0, 0, 0, 0, 0};
b_command bf_onbutton = {"ONBUTTON", bf_onbuttons, 0, 0, 0, 0, 0, 0};
b_command bf_ondown = {"ONDOWN", bf_ondowns, 0, 0, 0, 0, 0, 0};
b_command bf_onheld = {"ONHELD", bf_onhelds, 0, 0, 0, 0, 0, 0};
b_command bf_oninput = {"ONINPUT", bf_oninputs, 0, 0, 0, 0, 0, 0};
b_command bf_onframe = {"ONFRAME", bf_onframes, 0, 0, 0, 0, 0, 0};
b_command bf_ontimer = {"ONTIMER", bf_ontimers, 0, 0, 0, 0, 0, 0};
b_command bf_ondestroy = {"ONDESTROY", bf_ondestroys, 0, 0, 0, 0, 0, 0};
b_command bf_ontext = {"ONTEXT", bf_ontexts, 0, 0, 0, 0, 0, 0};

void basic_draw(TWidget * wid, ttk_surface srf);
int basic_scroll(TWidget * wid, int dir);
int basic_stap(TWidget * wid, int where);
int basic_button(TWidget * wid, int button, int time);
int basic_down(TWidget * wid, int button);
int basic_held(TWidget * wid, int button);
int basic_input(TWidget * wid, int ch);
int basic_frame(TWidget * wid);
int basic_timer(TWidget * wid);
void basic_destroy(TWidget * wid);
int basic_ti_callback(TWidget * wid, char * text);

void basic_widget_init(TWidget * wid, b_scope * sc);
void basic_tiwidget_init(TWidget * wid, b_scope * sc);

void bf_init_apiglue();

#endif

