#!/bin/basic -i

# LET BASIC include file for podzilla applications
# Copyright (C) 2006-2008 Rebecca G. Bettencourt
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

const pz_setting_int = pz_setting(1)
const pz_setting_string = pz_setting(2)
const pz_setting_float = pz_setting(3)
const pz_setting_ilist = pz_setting(4)
const pz_setting_slist = pz_setting(5)
const pz_setting_blob = pz_setting(6)

const pz_menu_donothing = pz_menu(1)
const pz_menu_upone = pz_menu(2)
const pz_menu_upall = pz_menu(3)
const pz_menu_alreadydone = pz_menu(4)
const pz_menu_quit = pz_menu(5)
const pz_menu_replace = pz_menu(6)
const pz_menu_descmax = pz_menu(7)

const pz_event_scroll = pz_event(1)
const pz_event_stap = pz_event(2)
const pz_event_button_up = pz_event(3)
const pz_event_button_down = pz_event(4)
const pz_event_button_held = pz_event(5)
const pz_event_button = pz_event(3)
const pz_event_down = pz_event(4)
const pz_event_held = pz_event(5)
const pz_event_input = pz_event(6)
const pz_event_frame = pz_event(7)
const pz_event_timer = pz_event(8)
const pz_event_destroy = pz_event(9)

const pz_button_menu = pz_button(1)
const pz_button_prevous = pz_button(2)
const pz_button_next = pz_button(3)
const pz_button_play = pz_button(4)
const pz_button_hold = pz_button(5)
const pz_button_action = pz_button(6)

const pz_window_normal = pz_window(1)
const pz_window_fullscreen = pz_window(2)
const pz_window_popup = pz_window(3)
const pz_window_xywh = pz_window(4)

const pz_dsp_linein = pz_dsp(1)
const pz_dsp_lineout = pz_dsp(2)
const pz_dsp_mic = pz_dsp(3)
const pz_dsp_max_vol = pz_dsp(4)

const ttk_pod_x11 = ttk_pod(0)
const ttk_pod_1g = ttk_pod(1)
const ttk_pod_2g = ttk_pod(2)
const ttk_pod_3g = ttk_pod(3)
const ttk_pod_4g = ttk_pod(4)
const ttk_pod_video = ttk_pod(5)
const ttk_pod_mini = ttk_pod(10)
const ttk_pod_mini_1g = ttk_pod(11)
const ttk_pod_mini_2g = ttk_pod(12)
const ttk_pod_photo = ttk_pod(13)
const ttk_pod_nano = ttk_pod(14)
const ttk_pod_pp5002 = ttk_pod(5002)
const ttk_pod_pp5020 = ttk_pod(5020)
const ttk_pod_pp5022 = ttk_pod(5022)
const ttk_pod_pp502x = ttk_pod(5029)

const ttk_button_action = ttk_button(1)
const ttk_button_previous = ttk_button(2)
const ttk_button_next = ttk_button(3)
const ttk_button_menu = ttk_button(4)
const ttk_button_play = ttk_button(5)
const ttk_button_hold = ttk_button(6)

const ttk_move_abs = ttk_move(1)
const ttk_move_rel = ttk_move(2)
const ttk_move_end = ttk_move(3)

const ttk_dirty_header = ttk_dirty(1)
const ttk_dirty_windowarea = ttk_dirty(2)
const ttk_filthy = ttk_dirty(3)

const ttk_ev_click = ttk_ev(1)
const ttk_ev_unused = ttk_ev(2)
const ttk_ev_done = ttk_ev(3)

const ttk_input_enter = ttk_input(1)
const ttk_input_bksp = ttk_input(2)
const ttk_input_left = ttk_input(3)
const ttk_input_right = ttk_input(4)
const ttk_input_end = ttk_input(5)

const white = ttk_bwcolor(1)
const grey = ttk_bwcolor(2)
const dkgrey = ttk_bwcolor(3)
const black = ttk_bwcolor(4)

function rgb(r as int, g as int, b as int) as int
	return (r*65536 + g*256 + b)
end function

function cmy(c as int, m as int, y as int) as int
	return ((255-c)*65536 + (255-m)*256 + (255-y))
end function

function hsv(h as float, s as float, v as float) as int
	dim vr as float
	dim vg as float
	dim vb as float
	dim r as int
	dim g as int
	dim b as int
	if (s = 0) then
		vr = v : vg = v : vb = v
	else
		vh = h*6
		while (vh < 0) : vh = vh+6 : wend
		while (vh >= 6) : vh = vh-6 : wend
		vi = floor(vh)
		v1 = v * (1 - s)
		v2 = v * (1 - s*(vh-vi))
		v3 = v * (1 - s*(1-(vh-vi)))
		select vi
			case 0 : vr = v  : vg = v3 : vb = v1
			case 1 : vr = v2 : vg = v  : vb = v1
			case 2 : vr = v1 : vg = v  : vb = v3
			case 3 : vr = v1 : vg = v2 : vb = v
			case 4 : vr = v3 : vg = v1 : vb = v
			case 5 : vr = v  : vg = v1 : vb = v2
		end select
	end if
	r=floor(vr*255) : g=floor(vg*255) : b=floor(vb*255)
	return (r*65536 + g*256 + b)
end function

class widget
	let address = 0
	
	sub destroyed()
		if address<>0 then
			rem destroy the widget!
		end if
	end sub
end class

