/*
 * LET BASIC = BASIC + 1
 * Copyright (C) 2006-2008 Rebecca G. Bettencourt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <math.h>

double fdiv(double a, double b)
{
	return floor(a/b);
}

double fmod(double a, double b)
{
	return a-floor(a/b)*b;
}

double factorial(int a)
{
	double d = 1.0;
	if (a<0) return 1.0/0.0;
	while (a) {
		d *= (double)a;
		a--;
	}
	return d;
}

double pick(int n, int r)
{
	double d = 1.0;
	int i;
	if (n<0 || r<0 || r>n) return 0.0;
	for (i=n; i>(n-r); i--) {
		d *= (double)i;
	}
	return d;
}

double choose(int n, int r)
{
	double d = 1.0;
	int i;
	if (n<0 || r<0 || r>n) return 0.0;
	for (i=n; i>(n-r); i--) {
		d *= (double)i;
	}
	for (i=r; i>0; i--) {
		d /= (double)i;
	}
	return d;
}

int gcd(int a, int b)
{
	while (b>0 && a>0) {
		if (b>a) { int c=b; b=a; a=c; }
		a %= b;
		if (a==0) return b;
		b %= a;
		if (b==0) return a;
	}
	return a;
}

int lcm(int a, int b)
{
	return (a*b)/gcd(a,b);
}

long gcdl(long a, long b)
{
	while (b>0 && a>0) {
		if (b>a) { long c=b; b=a; a=c; }
		a %= b;
		if (a==0) return b;
		b %= a;
		if (b==0) return a;
	}
	return a;
}

long lcml(long a, long b)
{
	return (a*b)/gcdl(a,b);
}

double cot(double a) { return 1/tan(a); }
double sec(double a) { return 1/cos(a); }
double csc(double a) { return 1/sin(a); }
double acot(double a) { return atan(1/a); }
double asec(double a) { return acos(1/a); }
double acsc(double a) { return asin(1/a); }
double coth(double a) { return 1/tanh(a); }
double sech(double a) { return 1/cosh(a); }
double csch(double a) { return 1/sinh(a); }
double acoth(double a) { return atanh(1/a); }
double asech(double a) { return acosh(1/a); }
double acsch(double a) { return asinh(1/a); }

#ifdef NEED_ROUND
double round(double a) { return floor(a+0.5); }
#endif

#ifdef NEED_TRUNC
double trunc(double a) { return (a>0)?floor(a):ceil(a); }
#endif
