/*
 * LET BASIC = BASIC + 1
 * Copyright (C) 2006-2008 Rebecca G. Bettencourt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef ____MATH_X_H____
#define ____MATH_X_H____

#include <math.h>

double fdiv(double a, double b);
double fmod(double a, double b);
double factorial(int a);
double pick(int n, int r);
double choose(int n, int r);

int gcd(int a, int b);
int lcm(int a, int b);
long gcdl(long a, long b);
long lcml(long a, long b);

double cot(double a);
double sec(double a);
double csc(double a);
double acot(double a);
double asec(double a);
double acsc(double a);
double coth(double a);
double sech(double a);
double csch(double a);
double acoth(double a);
double asech(double a);
double acsch(double a);

#ifdef NEED_ROUND
double round(double a);
#endif

#ifdef NEED_TRUNC
double trunc(double a);
#endif

#endif
