/*
 * LET BASIC = BASIC + 1
 * Copyright (C) 2006-2008 Rebecca G. Bettencourt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#ifdef NEED_STRCASESTR
char * strcasestr(char * s1, char * s2)
{
	int l = strlen(s2);
	char * b = s1;
	char * e = s1 + strlen(s1) - l;
	while (b>=e) {
		if (!strncasecmp(b,s2,l)) return b;
		b++;
	}
	return 0;
}
#endif

char * strrstr(char * a, char * b)
{
	int l = strlen(b);
	char * c = a+strlen(a)-l;
	while (c>=a) {
		if (!strncmp(c,b,l)) return c;
		c--;
	}
	return 0;
}

char * ltrim(char * c)
{
	char * b = 0;
	char * s = c;
	char * e = c+strlen(c);
	while ((*s) && isspace(*s)) s++;
	b = (char *)malloc(e-s+1);
	if (!b) return 0;
	strncpy(b,s,e-s);
	b[e-s] = 0;
	return b;
}

char * rtrim(char * c)
{
	char * b = 0;
	char * s = c;
	char * e = c+strlen(c);
	while ((e > s) && isspace(*(e-1))) e--;
	b = (char *)malloc(e-s+1);
	if (!b) return 0;
	strncpy(b,s,e-s);
	b[e-s] = 0;
	return b;
}

char * trim(char * c)
{
	char * b = 0;
	char * s = c;
	char * e = c+strlen(c);
	while ((*s) && isspace(*s)) s++;
	while ((e > s) && isspace(*(e-1))) e--;
	b = (char *)malloc(e-s+1);
	if (!b) return 0;
	strncpy(b,s,e-s);
	b[e-s] = 0;
	return b;
}

char * left(char * c, int l)
{
	char * b = 0;
	char * s = c;
	char * e = ( (l<strlen(c))?(c+l):(c+strlen(c)) );
	b = (char *)malloc(e-s+1);
	if (!b) return 0;
	strncpy(b,s,e-s);
	b[e-s] = 0;
	return b;
}

char * mid(char * c, int k)
{
	char * b = 0;
	char * s = ( (k<strlen(c))?(c+k):(c+strlen(c)) );
	char * e = c+strlen(c);
	b = (char *)malloc(e-s+1);
	if (!b) return 0;
	strncpy(b,s,e-s);
	b[e-s] = 0;
	return b;
}

char * mid2(char * c, int k, int l)
{
	char * b = 0;
	char * s = ( (k<strlen(c))?(c+k):(c+strlen(c)) );
	char * e = ( ((k+l)<strlen(c))?(c+k+l):(c+strlen(c)) );
	b = (char *)malloc(e-s+1);
	if (!b) return 0;
	strncpy(b,s,e-s);
	b[e-s] = 0;
	return b;
}

char * right(char * c, int l)
{
	char * b = 0;
	char * s = ( (l<strlen(c))?(c+strlen(c)-l):(c) );
	char * e = c+strlen(c);
	b = (char *)malloc(e-s+1);
	if (!b) return 0;
	strncpy(b,s,e-s);
	b[e-s] = 0;
	return b;
}

char * substr(char * s, char * e)
{
	char * b = (char *)malloc(e-s+1);
	if (!b) return 0;
	strncpy(b,s,e-s);
	b[e-s] = 0;
	return b;
}

char * substrim(char * s, char * e)
{
	while ((*s) && s<e && isspace(*s)) s++;
	while (s<e && isspace(*(e-1))) e--;
	return substr(s,e);
}

int instr(char * c, char * ch)
{
	char * x = strstr(c, ch);
	if (!x) return -1;
	return (x-c);
}

int rinstr(char * c, char * ch)
{
	char * x = strrstr(c, ch);
	if (!x) return -1;
	return (x-c);
}

char * ucase(char * s)
{
	char * b = strdup(s);
	int i;
	int n = strlen(b);
	for (i=0; i<n; i++) {
		if (islower(b[i])) b[i]-=32;
	}
	return b;
}

char * lcase(char * s)
{
	char * b = strdup(s);
	int i;
	int n = strlen(b);
	for (i=0; i<n; i++) {
		if (isupper(b[i])) b[i]+=32;
	}
	return b;
}

char * tcase(char * s)
{
	char * b = strdup(s);
	int i;
	int n = strlen(b);
	for (i=0; i<n; i++) {
		if (i==0 || !isalpha(b[i-1])) {
			if (islower(b[i])) b[i]-=32;
		} else {
			if (isupper(b[i])) b[i]+=32;
		}
	}
	return b;
}

char * chr(char ch)
{
	char * b = (char *)malloc(2);
	if (!b) return 0;
	b[0] = ch;
	b[1] = 0;
	return b;
}

char asc(char * c)
{
	if (!c) return 0;
	return (*c);
}

char * uchr(int ch)
{
	char * c = (char *)malloc(6);
	if (!c) return 0;
	if (ch < 0) {
		c[0]=('?');
		c[1]=0;
		c[5]=0;
	} else if (ch < 0x80) {
		c[0]=(ch);
		c[1]=0;
		c[5]=1;
	} else if (ch < 0x0800) {
		c[0]=((ch >> 6        ) | 0xC0);
		c[1]=((ch       & 0x3F) | 0x80);
		c[2]=0;
		c[5]=2;
	} else if (ch < 0x10000) {
		c[0]=((ch >> 12       ) | 0xE0);
		c[1]=((ch >> 6  & 0x3F) | 0x80);
		c[2]=((ch       & 0x3F) | 0x80);
		c[3]=0;
		c[5]=3;
	} else if (ch < 0x110000) {
		c[0]=((ch >> 18       ) | 0xF0);
		c[1]=((ch >> 12 & 0x3F) | 0x80);
		c[2]=((ch >> 6  & 0x3F) | 0x80);
		c[3]=((ch       & 0x3F) | 0x80);
		c[4]=0;
		c[5]=4;
	} else {
		c[0]=('?');
		c[1]=0;
		c[5]=0;
	}
	return c;
}

int uni(char * c)
{
	int ch = 0;
	int nb = 0;
	int h = (*c);
	while (h & 0x80) {
		nb++;
		h <<= 1;
	}
	if (nb) {
		ch = (*c) & (0xFF >> nb);
		nb--;
		if (!nb) return -1;
		while (nb) {
			c++;
			nb--;
			if (((*c) & 0xC0) != 0x80) return -1;
			ch = ((ch << 6) | ((*c) & 0x3F));
		}
	} else {
		ch = (*c);
	}
	return ch;
}

int charCount(char * s, char * e, char c1)
{
	char * b;
	int cnt = 0;
	for (b=s; b<e; b++) {
		if ((*b)==c1) cnt++;
	}
	return cnt;
}

int charCount2(char * s, char * e, char c1, char c2)
{
	char * b;
	int cnt = 0;
	for (b=s; b<e; b++) {
		if ((*b)==c1 || (*b)==c2) cnt++;
	}
	return cnt;
}

int charCount3(char * s, char * e, char c1, char c2, char c3)
{
	char * b;
	int cnt = 0;
	for (b=s; b<e; b++) {
		if ((*b)==c1 || (*b)==c2 || (*b)==c3) cnt++;
	}
	return cnt;
}

int charCount4(char * s, char * e, char c1, char c2, char c3, char c4)
{
	char * b;
	int cnt = 0;
	for (b=s; b<e; b++) {
		if ((*b)==c1 || (*b)==c2 || (*b)==c3 || (*b)==c4) cnt++;
	}
	return cnt;
}

int countFields(char * s, char * d)
{
	if (!s || !d || !(*s) || !(*d)) return 0;
	char * e = s+strlen(s);
	char * b;
	int cnt = 1;
	for (b=s; b<e; b++) {
		if (!strncmp(b,d,strlen(d))) cnt++;
	}
	return cnt;
}

char * nthField(char * s, char * d, int n)
{
	if (!s) return 0;
	if (!d || !(*d)) return strdup(s);
	if (!(*s) || n<1) return strdup("");
	char * e = s+strlen(s);
	char * b;
	char * fs = s;
	int cnt = 1;
	for (b=s; b<e; b++) {
		if (!strncmp(b,d,strlen(d))) {
			if (cnt == n) {
				return substrim(fs,b);
			} else {
				fs = b+strlen(d);
				cnt++;
			}
		}
	}
	if (cnt == n) {
		return substrim(fs,e);
	} else {
		return strdup("");
	}
}

char * replace(char * s, char * old, char * new)
{
	if (!s) return 0;
	if (!(*s) || !old || !(*old)) return strdup(s);
	if (!new) return replace(s,old,"");
	char * buf = calloc(1,strlen(s)+strlen(new)+1);
	char * p = s;
	char * q = buf;
	if (!buf) return 0;
	while (*p) {
		if (!strncmp(p,old,strlen(old))) {
			strcpy(q,new);
			p += strlen(old);
			q += strlen(new);
			
			strcpy(q,p);
			return buf;
		} else {
			(*q) = (*p);
			p++;
			q++;
		}
	}
	return buf;
}

char * replaceAll(char * s, char * old, char * new)
{
	if (!s) return 0;
	if (!(*s) || !old || !(*old)) return strdup(s);
	if (!new) return replaceAll(s,old,"");
	char * buf = calloc(1,strlen(s)+strlen(new)*countFields(s,old)+1);
	char * p = s;
	char * q = buf;
	if (!buf) return 0;
	while (*p) {
		if (!strncmp(p,old,strlen(old))) {
			strcpy(q,new);
			p += strlen(old);
			q += strlen(new);
		} else {
			(*q) = (*p);
			p++;
			q++;
		}
	}
	return buf;
}

